#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>



#define MAXN 60100



int N;
int e[MAXN][2];
int *g[MAXN];
int deg[MAXN];
int used[MAXN];
int ind[MAXN];
int nind;
int num[MAXN];
int nnum;
int sol[MAXN];
int islast[MAXN];
int st[MAXN];
int ist;
int U;
int P;
int AA;



void read_all(void);
void do_all(void);
void DFS(int u);
void DFS1(void);
void write_all(void);



int main(void)
{
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  int i, a, b;
  
  FILE *f = fopen("zad5.dat", "rt");
  fscanf(f, "%d", &N);
  for (i = 0; i < N-1; i++) {
    fscanf(f, "%d %d", &a, &b);  a--;  b--;
    deg[a]++;
    deg[b]++;
    g[a] = (int *)realloc(g[a], sizeof(*g[a])*deg[a]);
    g[b] = (int *)realloc(g[b], sizeof(*g[b])*deg[b]);
    g[a][deg[a]-1] = b;
    g[b][deg[b]-1] = a;
  }
  fclose(f);
}



void do_all(void)
{
  int i, u;
  
  nind = 0;
  DFS(0);
/*  for (i = 0; i < nind; i++) {
    printf("%d ", 1+ind[i]);
  }
  printf("\n");*/
  memset(used, 0, sizeof(used));
  for (i = nind-1; i >= 0; i--) {
    u = ind[i];
    if (used[u])  continue;
    used[u] = 1;
    islast[i] = 1;
  }
  memset(num, 0, sizeof(num));
  nnum = 1;
  st[ist++] = 0;
  DFS1();
}



void DFS(int u)
{
  int i, v;

  used[u] = 1;
  ind[nind++] = u;
  for (i = 0; i < deg[u]; i++) {
    v = g[u][i];
    if (used[v])  continue;
    DFS(v);
    ind[nind++] = u;
  }
}



void DFS1(void)
{
  int i;

  for (;;) {
    U = st[ist-1];
    if (U > AA) {
      AA = U;
    }
    if (U == nind) {
      int i;

      for (i = 0; i < N; i++) {
        if (num[i] == 0)  break;
      }
      if (i >= N) {
        for (i = 0; i < N; i++) {
          sol[num[i]-1] = i+1;
        }
        write_all();
        exit(0);
      }
      return;
    }
    if (num[ind[U]] > 0)  return;
    num[ind[U]] = nnum++;

    if (U+3 <= nind
    &&  !(islast[U+2] && num[ind[U+2]] == 0)
    &&  !(islast[U+1] && num[ind[U+1]] == 0)) {
      st[ist++] = U+3;
      continue;
    }
    if (U+2 <= nind
    &&  !(islast[U+1] && num[ind[U+1]] == 0)) {
      st[ist++] = U+2;
      continue;
    }
    if (U+1 <= nind) {
      st[ist++] = U+1;
      continue;
    }
    num[ind[U]] = 0;  --nnum;
  }
}



void write_all(void)
{
  int i;
  
  FILE *f = fopen("zad5.res", "wt");
/*  perror("1");*/
  for (i = 0; i < N; i++) {
    fprintf(f, "%d\n", sol[i]);
/*    printf("%d\n", sol[i]);*/
  }
  fclose(f);
}

