{$MODE objfpc}

Uses
  mergem;

Var
  N, K : Integer;
  Len : Array[0..10] Of Integer;
  CPos : Array[0..10] Of Integer;
  Cache : Array[0..10, 0..50000] Of Integer;
  Res : Integer;
  TotalNum : Integer;

Procedure WriteOut;

Var
  F : Text;

Begin
  ASSign(F, 'ZAD2.RES');
  Rewrite(F);
  Writeln(F, Res);
  Close(F);
End;

Function geta_cached(I, J : Integer) : Integer;

Begin
  If J > Len[I] Then
    Exit($7FFFFFFF);
  If J <= 0 Then
    Exit(-1);
  If Cache[I, J] = -1 Then
  Begin
    Cache[I, J] := GetA(I, J);
{    Write('.');}
  End;
  geta_cached := Cache[I, J];
End;

Procedure ReadIn;

Var
  I : Integer;

Begin
  Init;
  N := GetN;
  K := GetK;
  TotalNum := 0;
  For I := 1 To N Do
  Begin
    Len[I] := GetLen(I);
    Inc(TotalNum, Len[I]);
  End;
End;

Function NextBahur : Integer;

Var
  min, mini : Integer;
  newm : Integer;
  I : Integer;

Begin
  min := $7FFFFFFF;
  For I := 1 To N Do
  Begin
    newm := geta_cached(I, CPos[I]);
    If newm <= min Then
    Begin
      min := newm;
      mini := I;
    End;
  End;
  Inc(CPos[mini]);
  NextBahur := min;
End;

Function NextBahur2 : Integer;

Var
  max, maxi : Integer;
  newm : Integer;
  I : Integer;

Begin
  max := -1;
  For I := 1 To N Do
  Begin
    newm := geta_cached(I, CPos[I]);
    If newm >= max Then
    Begin
      max := newm;
      maxi := I;
    End;
  End;
  Dec(CPos[maxi]);
  NextBahur2 := max;
End;

Procedure Bahur;

Var
  I : Integer;

Begin
  For I := 1 To N Do
    CPos[I] := 1;
  For I := 1 To K Do
    Res := NextBahur;
End;

Procedure Bahur2;

Var
  I : Integer;

Begin
  For I := 1 To N Do
    CPos[I] := Len[I];
  For I := TotalNum DownTo K Do
    Res := NextBahur2;
End;

Begin
  FillChar(Cache, SizeOf(Cache), $FF);
  ReadIn;
  If K <= (TotalNum Div 2) Then
    Bahur
  Else
    Bahur2;
  WriteOut;
End.
