{$MODE objfpc}

Uses
  SysUtils;

Const
  timelimit = 34;

Var
  N, K : Integer;
  G : Array[0..1023, 0..1023] Of Boolean;
  V : Array[0..1000] Of Boolean;
  Num1 : Array[0..1000] Of Integer;
  Num2 : Array[0..1000] Of Integer;
  compsz : Array[0..1000] Of Integer;
  pathlen : Integer;
  path : Array[0..1000] Of Integer;
  CompNum : Integer;
  CComp : Integer;
  gn : Integer;
  vnum : Integer;
  Start : Integer;
  starttime : Word;
  ctime : Word;

Procedure WriteOut;

Var
  I : Integer;
  F : Text;

Begin
  ASSign(F, 'ZAD3.RES');
  Rewrite(F);
  If pathlen <> 0 Then
  Begin
    Write(F, path[1]);
    For I := 2 To pathlen Do
      Write(F, ' ', path[I]);
    Writeln(F);
  End
  Else
    Writeln(F, 0);
  Close(F);
  Halt;
End;

Procedure WriteOutZero;

Begin
  pathlen := 0;
  WriteOut;
End;

Procedure ReadIn;

Var
  F : Text;
  I : Integer;
  A, B : Integer;

Begin
  ASSign(F, 'ZAD3.DAT');
  Reset(F);
  Readln(F, N, K);
  For I := 1 To (N * (N - 1)) Div 2 Do
  Begin
    Readln(F, A, B);
    G[A, B] := True;
  End;
  Close(F);
End;

Procedure Dig1(Q : Integer);

Var
  I : Integer;

Begin
  If V[Q] Then
    Exit;
  V[Q] := True;
  For I := 1 To N Do
    If G[Q, I] Then
      Dig1(I);
  Inc(gn);
  Num1[Q] := gn;
End;

Procedure Dig2(Q : Integer);

Var
  I : Integer;

Begin
  If V[Q] Then
    Exit;
  V[Q] := True;
  Inc(vnum);
  For I := 1 To N Do
    If G[I, Q] Then
      Dig2(I);
  Num2[Q] := gn;
End;

Procedure Dig3(Q : Integer);

Var
  I : Integer;

Begin
  If (Word(Word(MemW[$46C]) - Word(starttime))) > Word(timelimit) Then
    Raise Exception.Create('timeout');

  If Num2[Q] <> CComp Then
    Exit;
  If V[Q] Then
    Exit;
  V[Q] := True;
  Inc(pathlen);
  path[pathlen] := Q;
  If pathlen = K Then
  Begin
    If G[Q, Start] Then
      WriteOut;
  End
  Else
    For I := 1 To N Do
      If G[Q, I] Then
        Dig3(I);

  V[Q] := False;
  Dec(pathlen);
End;

Procedure Bahur;

Var
  I, J : Integer;
  max, maxI : Integer;

Begin
  FillChar(V, SizeOf(V), 0);
  gn := 0;
  For I := 1 To N Do
    If Not V[I] Then
      Dig1(I);
{  For I := 1 To N Do
    Writeln(Num1[I]);}
  FillChar(V, SizeOf(V), 0);
  vnum := 0;
  gn := 0;
  While vnum < N Do
  Begin
    max := 0;
    For I := 1 To N Do
      If (Not V[I]) And (Num1[I] > max) Then
      Begin
        maxI := I;
        max := Num1[I];
      End;
    Inc(gn);
    Dig2(maxI);
  End;
{  For I := 1 To N Do
    Writeln(Num2[I]);}
  CompNum := gn;
  For I := 1 To N Do
    Inc(compsz[Num2[I]]);

{  For I := 1 To CompNum Do
    Writeln(compsz[I]);}
  FillChar(V, SizeOf(V), 0);
  For I := 1 To N Do
  Begin
    CComp := Num2[I];
    If compsz[CComp] < K Then
      Continue;
    Start := I;
    Dig3(I);
  End;
  Raise Exception.Create('notfound');
End;

Begin
  ReadIn;

  Try
    starttime := MemW[$46C];
{    ctime := starttime;}
{    Repeat
      Inc(ctime);
      If (ctime And $FF) = 0 Then
        Writeln(Word(Word(ctime) - Word(starttime)), ' ', ctime);
    Until False;}
    Bahur;
  Except
    WriteOutZero;
  End;
End.
