#include <stdio.h>

FILE *fn;
int n, k;
int neis[1024];
int nei[1024][1024];
int lev[1024];
int lvl[1024];
int rea[1024];
int from, to;

int dfs(int v, int l) {
  int i;

  lev[v]=l;
  lvl[l]=v;
  rea[v]=1;
  for (i=0; i<neis[v]; i++) {
    if (lev[nei[v][i]]) {
      if (lev[nei[v][i]]==l-k+1) {
        from=lev[nei[v][i]];
        to=l;
        break;
      }
    } else {
      if (dfs(nei[v][i], l+1)) break;
    }
  }
  if (i<neis[v]) return 1;
  else {
    lev[v]=0;
    return 0;
  }
}

int main(void) {
int i, t1, t2;

fn=fopen("ZAD3.DAT", "r");
fscanf(fn, "%d %d", &n, &k);
while (fscanf(fn, "%d %d", &t1, &t2)==2) {
  nei[t1][neis[t1]]=t2;
  neis[t1]++;
}
fclose(fn);

fn=fopen("ZAD3.RES", "w");
for (i=1; i<=n; i++) if (!rea[i]) {
  if (dfs(i, 1)) break;
}
if (i<=n) {
  fprintf(fn, "%d", lvl[from]);
  for (i=from+1; i<=to; i++) fprintf(fn, " %d", lvl[i]);
  fprintf(fn, "\n");
} else fprintf(fn, "0\n");
fclose(fn);

return 0;
}
