#include <stdio.h>

FILE *fn;

int n;
int neis[32768];
int *nei[32768];
int fat[32768];

void dfs(int v, int mode) {
  int i;

  if (mode) fprintf(fn, "%d\n", v);
  for (i=0; i<neis[v]; i++) if (nei[v][i]!=fat[v]) {
    fat[nei[v][i]]=v;
    dfs(nei[v][i], !mode);
  }
  if (!mode) fprintf(fn, "%d\n", v);
}

int main(void) {
int i, t1, t2;

fn=fopen("ZAD5.DAT", "r");
fscanf(fn, "%d", &n);
while (fscanf(fn, "%d", &t1)==1) neis[t1]++;
fclose(fn);
for (i=1; i<=n; i++) {
  nei[i]=(int *)malloc(4*neis[i]+8);
  neis[i]=0;
}
fn=fopen("ZAD5.DAT", "r");
fscanf(fn, "%d", &n);
for (i=1; i<n; i++) {
  fscanf(fn, "%d %d", &t1, &t2);
  nei[t1][neis[t1]]=t2;
  neis[t1]++;
  nei[t2][neis[t2]]=t1;
  neis[t2]++;
}
fclose(fn);

fn=fopen("ZAD5.RES", "w");
dfs(1, 1);
fclose(fn);

return 0;
}
