{$MODE objfpc}

Var
  N : Integer;
  G : Array[0..2047, 0..2047] Of Boolean;
  V : Array[0..2047] Of Boolean;
  Path : Array[0..2047] Of Integer;
  PathLen : Integer;

Procedure WriteOut;

Var
  I : Integer;
  F : Text;

Begin
  ASSign(F, 'ZAD5.RES');
  Rewrite(F);
  For I := 1 To N Do
    Writeln(F, Path[I]);
  Close(F);
  Halt;
End;

Procedure ReadIn;

Var
  F : Text;
  I : Integer;
  A, B : Integer;

Begin
  ASSign(F, 'ZAD5.DAT');
  Reset(F);
  Readln(F, N);
  For I := 1 To N - 1 Do
  Begin
    Readln(F, A, B);
    G[A, B] := True;
    G[B, A] := True;
  End;
  Close(F);
End;

Procedure Bahur(Q : Integer);

Var
  I, J, K : Integer;

Begin
  If V[Q] Then
    Exit;
  V[Q] := True;
  Inc(PathLen);
  Path[PathLen] := Q;
  If PathLen = N Then
    WriteOut;
  For I := 1 To N Do
    If G[Q, I] Then
    Begin
      For J := 1 To N Do
        If G[I, J] Then
        Begin
          Bahur(J);
          For K := 1 To N Do
            If G[J, K] Then
              Bahur(K);
        End;
      Bahur(I);
    End;

  Dec(PathLen);
  V[Q] := False;
End;

Var
  I : Integer;

Begin
  ReadIn;
  For I := 1 To N Do
    Bahur(I);
End.
