#include <stdio.h>

FILE *fn;
int m, n;
int ubx[32];
int uby[32];
int lbx[32];
int lby[32];
int px[128];
int py[128];
int dists;
int dist[16384][4];
int pts[128];
int pt[128][128];
int wgrp[128];

int cmp(int *a, int *b) {
  return *a-*b;
}

int main(void) {
int i, j, tx, ty, t1;

fn=fopen("ZAD1.DAT", "r");
fscanf(fn, "%d", &m);
for (i=0; i<=m; i++) fscanf(fn, "%d %d", &ubx[i], &uby[i]);
for (i=0; i<=m; i++) fscanf(fn, "%d %d", &lbx[i], &lby[i]);
fscanf(fn, "%d", &n);
for (i=0; i<n; i++) fscanf(fn, "%d %d", &px[i], &py[i]);
fclose(fn);

for (i=0; i<n; i++) {
  for (j=i+1; j<n; j++) {
    if (px[i]<px[j]) tx=px[j]-px[i];
    else tx=px[i]-px[j];
    if (py[i]<py[j]) ty=py[j]-py[i];
    else ty=py[i]-py[j];
    if (tx>ty) dist[dists][0]=tx;
    else dist[dists][0]=ty;
    dist[dists][1]=i;
    dist[dists][2]=j;
    dists++;
  }
  t1=2000000;
  for (j=0; j<=m; j++) {
    if (px[i]<ubx[j]) tx=ubx[j]-px[i];
    else tx=px[i]-ubx[j];
    if (py[i]<uby[j]) ty=uby[j]-py[i];
    else ty=py[i]-uby[j];
    if (ty>tx) tx=ty;
    if (tx<t1) t1=tx;
  }
  for (j=1; j<=m; j++) {
    if (ubx[j]==ubx[j-1]) {
      if ((py[i]<=uby[j] && py[i]>=uby[j-1]) || (py[i]<=uby[j-1] && py[i]>=uby[j])) {
        tx=px[i]-ubx[j];
        if (tx<0) tx*=-1;
        if (tx<t1) t1=tx;
      }
    } else {
      if ((px[i]<=ubx[j] && px[i]>=ubx[j-1]) || (px[i]<=ubx[j-1] && px[i]>=ubx[j])) {
        tx=py[i]-uby[j];
        if (tx<0) tx*=-1;
        if (tx<t1) t1=tx;
      }
    }
  }
  dist[dists][0]=t1;
  dist[dists][1]=i;
  dist[dists][2]=n;
  dists++;
  t1=2000000;
  for (j=0; j<=m; j++) {
    if (px[i]<lbx[j]) tx=lbx[j]-px[i];
    else tx=px[i]-lbx[j];
    if (py[i]<lby[j]) ty=lby[j]-py[i];
    else ty=py[i]-lby[j];
    if (ty>tx) tx=ty;
    if (tx<t1) t1=tx;
  }
  for (j=1; j<=m; j++) {
    if (lbx[j]==lbx[j-1]) {
      if ((py[i]<=lby[j] && py[i]>=lby[j-1]) || (py[i]<=lby[j-1] && py[i]>=lby[j])) {
        tx=px[i]-lbx[j];
        if (tx<0) tx*=-1;
        if (tx<t1) t1=tx;
      }
    } else {
      if ((px[i]<=lbx[j] && px[i]>=lbx[j-1]) || (px[i]<=lbx[j-1] && px[i]>=lbx[j])) {
        tx=py[i]-lby[j];
        if (tx<0) tx*=-1;
        if (tx<t1) t1=tx;
      }
    }
  }
  dist[dists][0]=t1;
  dist[dists][1]=i;
  dist[dists][2]=n+1;
  dists++;
}
t1=2000000;
for (i=1; i<=m; i++) {
  if (ubx[i]==ubx[i-1]) {
    ty=ubx[i]-lbx[i];
    if (ty<0) ty*=-1;
    if (ty<t1) t1=ty;
  } else {
    ty=uby[i]-lby[i];
    if (ty<0) ty*=-1;
    if (ty<t1) t1=ty;
  }
}
dist[dists][0]=t1;
dist[dists][1]=n;
dist[dists][2]=n+1;
dists++;
qsort(dist, dists, sizeof(dist[0]), cmp);
for (i=0; i<=n+1; i++) {
  pt[i][0]=i;
  pts[i]=1;
  wgrp[i]=i;
}
for (i=0; i<dists; i++) {
  if (wgrp[dist[i][1]]!=wgrp[dist[i][2]]) {
    tx=wgrp[dist[i][1]];
    ty=wgrp[dist[i][2]];
    for (j=0; j<pts[ty]; j++) {
      wgrp[pt[ty][j]]=tx;
      pt[tx][pts[tx]+j]=pt[ty][j];
    }
    pts[tx]+=pts[ty];
    pts[ty]=0;
    if (wgrp[n]==wgrp[n+1]) break;
  }
}

fn=fopen("ZAD1.RES", "w");
fprintf(fn, "%d\n", dist[i][0]);
fclose(fn);

return 0;
}
