#include <stdio.h>

typedef struct {
  int x,y;
} pt;

int m,n;

pt up[32],dn[32];
pt pr[128];

int min(int a,int b)
{
  if (a<b) { return a; } else { return b; }
}

int max(int a,int b)
{
  if (a>b) { return a; } else { return b; }
}

int ISIN(int a,int b,int c)
{
  if ((a>=b) && (a<=c)) { return 1; } else { return 0; }
}

int gr[128][128];
int wel[128];
int inv[128];

int clc[128];

int dst(int x1,int y1,int x2,int y2,int x3,int y3)
{
  int d;

//  if (x1>x2) { d=x1; x1=x2; x2=d; }
//  if (y1>y2) { d=y1; y1=y2; y2=d; }

  if (y1==y2)
  {
    d = abs(y3-y1);
    if (ISIN(x3,min(x1,x2),max(x1,x2))==0)
      { d=max(d, min(abs(x3-x1),abs(x3-x2)) ); }
  } else { // x1=x2
    d = abs(x3-x1);
    if (ISIN(y3,min(y1,y2),max(y1,y2))==0)
      { d=max(d, min(abs(y3-y1),abs(y3-y2)) ); }
  }
//  printf("CLL : %d %d %d %d - %d %d %d\n",x1,y1,x2,y2,x3,y3,d);

  return d;
}

int printgr(void)
{
  int i,j;
  for (j=0;j<n+2;j++)
  {
    for (i=0;i<n+2;i++)
    {
      printf("%d ",gr[j][i]);
    }
    printf("\n");    
  }

}

int pass(int x1,int y1,int x2,int y2,int h0,int h)
{
  int i,j,v,v1;

  for (i=0;i<n;i++)
  {
    if ((ISIN(pr[i].x,x1,x2)) && (ISIN(pr[i].y,y1,y2)))
    {
      clc[i]=1;
    }  else { clc[i]=0; }
  }

  for (j=0;j<n;j++)
  {
    if (clc[j]==0) { continue; }
    
    for (i=j+1;i<n;i++)
    {
      if (clc[i]==0) { continue; }
    
      v = max(abs(pr[i].x-pr[j].x),abs(pr[i].y-pr[j].y));
      
      gr[i][j]=v;
      gr[j][i]=v;
    }
  }
  
  for (i=0;i<n;i++)
  {
    if (clc[i]==0) { continue; }
  
    v = dst( up[h].x , up[h].y , up[h+1].x , up[h+1].y , pr[i].x , pr[i].y );
    v1 = dst( dn[h].x , dn[h].y , dn[h+1].x , dn[h+1].y , pr[i].x , pr[i].y );
    
    gr[n][i] = min(gr[n][i],v);
    gr[i][n] = min(gr[i][n],v);
    gr[n+1][i] = min(gr[n+1][i],v1);
    gr[i][n+1] = min(gr[i][n+1],v1);
  }

  

  if (h0==0) {
    v = y2-y1;
  } else { v=x2-x1; }
  
  gr[n][n+1] = min(v,gr[n][n+1]);
  gr[n+1][n] = min(v,gr[n+1][n]);

  return 0;
}


int deik(void)
{
  int c,i,v,v1;
  c = n+2;

  for (i=0;i<c;i++)
  {
    wel[i]=0x7FFF;
    inv[i]=0;
  }
  wel[c-2] = 0;

  for (;;)
  {
    v1 = 0x7fff; v=-1;
    for (i=0;i<c;i++)
    {
      if (inv[i]==0)
      {
        if (wel[i]<v1) { v1=wel[i]; v=i; }
      }
    }
    if (v<0) { break; }
    inv[v] = 1;

    for (i=0;i<c;i++)
    {
      if ((inv[i]==0) && (gr[v][i]<0x7fff))
      {
        wel[i] = min( max(v1,gr[v][i]) , wel[i] );
      }
    }
  }

  
  return wel[c-1];
}


int main(void)
{
  FILE* f;
  int i,a,b,c,d,r;
  f = fopen("zad1.dat","rt");
  fscanf(f,"%d ",&m);
  for (i=0;i<=m;i++)
  {
    fscanf(f,"%d %d ",&up[i].x,&up[i].y);
  }
  for (i=0;i<=m;i++)
  {
    fscanf(f,"%d %d ",&dn[i].x,&dn[i].y);
  }
  fscanf(f,"%d ",&n);
  for (i=0;i<n;i++)
  {
    fscanf(f,"%d %d ",&pr[i].x,&pr[i].y);
  }
  fclose(f);

  memset(gr,0x11,128*128*sizeof(int));

  for (i=0;i<m;i++)
  {
    a = min( min( up[i].x , up[i+1].x ) , min( dn[i].x , dn[i+1].x ) );
    b = min( min( up[i].y , up[i+1].y ) , min( dn[i].y , dn[i+1].y ) );
    c = max( max( up[i].x , up[i+1].x ) , max( dn[i].x , dn[i+1].x ) );
    d = max( max( up[i].y , up[i+1].y ) , max( dn[i].y , dn[i+1].y ) );

    pass(a,b,c,d,i%2,i);

//    if (r1<r) { r=r1; }
  }


  r = deik();

//  printgr();

  f = fopen("zad1.res","wt");
  fprintf(f,"%d\n",r);
  fclose(f);
  
  return 0;
}
