#include <stdio.h>
#include <math.h>

#define IMEC 1024

int ix[IMEC],iy[IMEC];
int ic[IMEC];
int is[IMEC][IMEC];
char iu[IMEC][IMEC];

int n,k;
int fst,fst1;

int insta[IMEC];
int sta[IMEC];
int stac;

int res;

int ors(int x1,int y1,int x2,int y2,int x3,int y3)
{
  return ( x1 * (y2-y3) + x2*(y3-y1) + x3*(y1-y2) );
}

int orsp(int p1,int p2,int p3)
{
  return ors(ix[p1],iy[p1], ix[p2],iy[p2], ix[p3],iy[p3] );
}

int dfs(int a,int b)
{
  int i,cou,c,c0,oldp,newp;

//  printf("%2d %2d   ",a+1,b+1);

  if ((stac) && ((fst==a) && (fst1==b)) )
  {
/*    printf("Match %d : ",stac);
    for (i=0;i<stac;i++)
    {
      printf("%d ",sta[i]+1);
    }
    printf("\n");  */
    if (stac==k) { res++; }
    return 0;
  }
    
  if ((insta[b]) || (iu[a][b]==1)) { return 0; }
  
  iu[a][b] = 1;
  insta[b]=1;
  sta[stac]=b;
  stac++;

  cou = ic[b];
//  if (cou<=1) { return 0; }

  c0=-1;
  for (i=0;i<cou;i++)
  {
    c=is[b][i];
    if (c!=a)
    {
      if (c0==-1) { c0=c; oldp=orsp(a,b,c); continue; }

      newp = orsp(a,b,c);

      if ((newp<0) && (oldp>=0)) { continue; }      
      if ((oldp<0) && (newp>=0)) { oldp=1; c0=c; } else
      {
        if (orsp(b,c0,c)>0) { c0=c; }
      }
    }
  }

  if (c0!=-1) { dfs(b,c0); }

  insta[b]=0;
  stac--;
  return 0;
}

int main(void)
{
  FILE* f;
  int i,j,c,minx,minp;
  f = fopen("zad6.dat","rt");

  minx = 0x3f3f3f3f;
  
  fscanf(f,"%d ",&n);
  for (j=0;j<n;j++)
  {
    fscanf(f,"%d %d %d ",&ix[j],&iy[j],&c);
    if (ix[j]<minx) { minx=ix[j]; minp=j; }
    for (i=0;i<c;i++)
    {
      fscanf(f,"%d ",&is[j][i]); is[j][i]--;
    }
    ic[j]=c;
  }
  fscanf(f,"%d ",&k);
  fclose(f);

  ix[n] = -1;
  iy[n] = 0;
  ic[n] = 1;
  is[n][0] = minp;
  
  is[minp][ic[minp]] = n;
  ic[minp]++;
  n++;

//  printf("Start\n");
  for (j=0;j<n;j++)
  {
    c = ic[j];
    for (i=0;i<c;i++)
    {
      if (iu[j][i]==0)
      {
      
//        printf("   dfs: ");
        fst=j; fst1=is[j][i];
        dfs(j,fst1);
      }
    }
  }

  f = fopen("zad6.res","wt");
  fprintf(f,"%d\n",res);
  fclose(f);
  
  return 0;
}
